#include "greetlib.h"
#include "greet.h"
#include <string>

using namespace System;
using namespace System::Text;

/*
 * std::wstring  System::String
 */
String^ ToCLI(const std::wstring& input) {
  return gcnew String(input.data(), 0, input.size());
}

/*
 * System::String^  std::wstring
 */
std::wstring FromCLI(String^ input) {
  std::wstring result;
  if ( input != nullptr && input->Length > 0 ) {
    pin_ptr<wchar_t> pin = &input->ToCharArray()[0];
    result.assign(pin, input->Length);
  }
  return result;
}


String^ GreetLib::Greet(String^ name) {
  return ToCLI(wgreet(FromCLI(name).c_str()));
}
